#include "../dnet/dnet.h"
#include <iostream>

#include <CGAL/point_generators_2.h>

using namespace dnet;

int main(int argc, char *argv[] )
{
  double epsilon = 0.5;
  size_t num_extrapoints; // unused
  std::vector<Point> points;
  std::vector<Circle> disks;
  std::vector<size_t> epsnet;
  std::vector<size_t> hittingset;
  int numpoints = 10000, numdisks=10000;

  // random points and disks
  CGAL::Random_points_in_square_2<Point> gen(0.5);
  CGAL::cpp11::copy_n( gen, numpoints, std::back_inserter(points) );
  std::vector<Point> rs;
  CGAL::cpp11::copy_n(gen,numdisks,std::back_inserter(rs));
  disks.reserve(numdisks);
  for ( size_t i = 0; i < numdisks ; ++i)
    disks.push_back(Circle(rs[i],0.2));

  // compute an epsilon-net
  //std::vector<double> weights(1.0/points.size(),points.size());
  std::vector<double> weights(points.size(),1.0/points.size());
  size_t initialSample = enet::randomSampleEpsnet(points, weights, epsilon, epsnet, num_extrapoints);

  // compute hitting set
  bg_solve(points, disks, hittingset);

  return EXIT_SUCCESS;
};